unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, StdCtrls, Buttons, JvSpin, Mask, JvExMask,
  JvExStdCtrls, ExtCtrls,
  ShellAPI, JvRichEdit, JvToolEdit, ComCtrls, JvComponentBase, JvDragDrop;

type
  TForm1 = class(TForm)
    open_folder: TJvDirectoryEdit;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    JvSpinEdit1: TJvSpinEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    XPManifest1: TXPManifest;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Button1: TButton;
    StatusBar1: TStatusBar;
    Naming: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    progress1: TProgressBar;
    Text: TMemo;
    JvDragDrop1: TJvDragDrop;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure open_folderClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure JvDragDrop1Drop(Sender: TObject; Pos: TPoint; Value: TStrings);
  private
    { Private declarations }
  public
    { Public declarations }
    Text_chunk: TStringList;
    File_name, extension, File_name2: String;
    stop: Boolean;
  end;

var
  Form1: TForm1;

implementation

uses About;

{$R *.dfm}

function ExtractExtension(FileName: String): String;
var
  i, x: Integer;
  s: String;
begin
  s := ExtractFileName(FileName);
  if Length(s) < 1 then
    Result := s;

  x := 0;
  for i := Length(s) downto 1 do
    if s[i] = '.' then
    begin
      x := i;
      break;
    end;

  if x > 1 then
    Result := Copy(s, x + 1, Length(s) - x)
  else
    Result := s;
end;

Function GetFileSize(FileName: String): Int64; // To get file size
var
  SearchRec: TSearchRec;
begin
  if FindFirst(FileName, faAnyFile, SearchRec) = 0 then // if found
    Result := Int64(SearchRec.FindData.nFileSizeHigh) shl Int64(32) +
    // calculate the size
      Int64(SearchRec.FindData.nFileSizeLow)
  else
    Result := 0;
  FindClose(SearchRec); // close the find
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Text_chunk := TStringList.Create;
  stop := False;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin

  FreeAndNil(Text_chunk);

end;

procedure TForm1.JvDragDrop1Drop(Sender: TObject; Pos: TPoint; Value: TStrings);
begin

  Text.Lines.BeginUpdate;
  progress1.Style := pbstMarquee;

  try
    File_name := Value.Strings[0];
    StatusBar1.Panels[4].Text := 'Cleaning text...';
    Text.Lines.Clear;
    StatusBar1.Panels[4].Text := 'Loading the file...';
    Text.Lines.LoadFromFile(File_name);

  finally
    Text.Lines.EndUpdate;

    JvSpinEdit1.MaxValue := Text.Lines.Count;
    StatusBar1.Panels[0].Text := ExtractFileName(Value.Strings[0]);
    SetCurrentDir(ExtractFilePath(Value.Strings[0]));
    open_folder.InitialDir := ExtractFileDir(Value.Strings[0]);

    progress1.Style := pbstNormal;
  end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if (Text.Lines.Count <> 0) then
  begin
    StatusBar1.Panels[1].Text := FloatToStr(Text.Lines.Count) + ' Lines';
    StatusBar1.Panels[2].Text := FloatToStr(GetFileSize(File_name) div 1024) +
      ' kbytes';
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin

  if (OpenDialog1.Execute) then
  begin
    File_name := OpenDialog1.FileName;

    if (FileExists(File_name)) then
    begin
      Text.Lines.BeginUpdate;
      progress1.Style := pbstMarquee;

      try

        StatusBar1.Panels[4].Text := 'Cleaning text...';
        Text.Lines.Clear;
        StatusBar1.Panels[4].Text := 'Loading the file...';
        Text.Lines.LoadFromFile(File_name);

      finally
        Text.Lines.EndUpdate;
        progress1.Style := pbstNormal;

        JvSpinEdit1.MaxValue := Text.Lines.Count;
        StatusBar1.Panels[0].Text := ExtractFileName(File_name);
        SetCurrentDir(ExtractFilePath(File_name));
        open_folder.InitialDir := ExtractFileDir(File_name);
        StatusBar1.Panels[4].Text := '';
      end;

    end;

  end;

end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  if (Text.Lines.Count <> 0) and (File_name <> '') then
  begin
    File_name := '';
    Text.Lines.Clear;
    StatusBar1.Panels[0].Text := '';
    StatusBar1.Panels[1].Text := '';
    StatusBar1.Panels[2].Text := '';
    StatusBar1.Panels[4].Text := '';
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i, j, numofchunks, firstline, lastline, numberoflines: Integer;
  FileName: String;
begin
  if (File_name = '') then
  begin
    Application.MessageBox('File is not selected.', 'Error');
    exit;
  end;

  if (Text.Lines.Count = 0) then
  begin
    Application.MessageBox('No text to splitt.', 'Error');
    exit;
  end;

  if (open_folder.Text = '') or (open_folder.Text = 'Select Output Folder') then
  begin
    Application.MessageBox('Output folder is not selected.', 'Error');
    exit;
  end;

  if (Not DirectoryExists(open_folder.Text)) then
  begin
    Application.MessageBox('Selected folder does not exists.', 'Error');
    exit;
  end;

  // --Let's begin--
  { What do we do here? Well, it gets number of the lines of the file and number
    of the chuncks you specify. Then it determinds number of the lines for per chunk.
    But if some lines left, it adds them to last chunk. That's it! Simple and usefull! }
  numofchunks := Round(JvSpinEdit1.Value); // --Get number of chunks--
  numberoflines := Text.Lines.Count div numofchunks;
  // --Find out number of lines for per chunk
  progress1.Max := numofchunks;
  BitBtn5.Enabled := True;
  BitBtn1.Enabled := False;
  GroupBox2.Enabled := False;
  BitBtn2.Enabled := False;
  BitBtn3.Enabled := False;
  open_folder.Enabled := False;
  Button1.Enabled := False;
  Text.Enabled := False;
  for i := 0 to numofchunks - 1 do
  begin
    if (stop = True) then // --If stopped by user
    begin
      ShowMessage('Stopped by user!');
      stop := False;
      BitBtn1.Enabled := True;
      BitBtn5.Enabled := False;
      GroupBox2.Enabled := True;
      BitBtn2.Enabled := True;
      BitBtn3.Enabled := True;
      open_folder.Enabled := True;
      Button1.Enabled := True;
      Text.Enabled := True;
      progress1.Position := 0;
      StatusBar1.Panels[2].Text := '%0';
      StatusBar1.Panels[3].Text := '';
      exit;
    end;
    Application.ProcessMessages;
    StatusBar1.Panels[4].Text := 'Splitting...';
    if (i <> numofchunks) then
    begin
      progress1.Position := i + 1;
      StatusBar1.Panels[3].Text := '%' +
        FloatToStr((100 * (i + 1)) div progress1.Max);
      if (i = numofchunks - 1) then
      begin
        firstline := i * numberoflines;
        lastline := Text.Lines.Count - 1;
      end
      else
      begin
        firstline := i * numberoflines;
        lastline := firstline + numberoflines - 1;
      end;
      for j := firstline to lastline do
      begin
        Text_chunk.Add(Text.Lines.Strings[j]);
      end;
      extension := ExtractExtension(File_name);
      File_name2 := ExtractFileName(File_name);
      Delete(File_name2, Length(File_name2) - 3, 4);

      if (RadioButton1.Checked) then
      begin
        FileName := open_folder.Text + '\' + File_name2 + 'Part' +
          FloatToStr(i + 1) + '.' + extension;
      end
      else if (RadioButton2.Checked) then
      begin
        FileName := open_folder.Text + '\' + 'Part' + FloatToStr(i + 1) + '.' +
          extension;
      end
      else if (RadioButton3.Checked) then
      begin
        FileName := open_folder.Text + '\' + FloatToStr(i + 1) + '.' +
          extension;
      end;
      Text_chunk.SaveToFile(FileName);

      Sleep(100);

      if (FileExists(FileName)) then
      begin
        Text_chunk.Clear;
      end;
    end;
    if (i = numofchunks - 1) then // --If last one is reached
    begin
      Application.MessageBox('File is splitted successfully!',
        'Text Splitter -Done-');
      stop := False;
      BitBtn1.Enabled := True;
      BitBtn5.Enabled := False;
      GroupBox2.Enabled := True;
      BitBtn2.Enabled := True;
      BitBtn3.Enabled := True;
      open_folder.Enabled := True;
      Button1.Enabled := True;
      Text.Enabled := True;
      progress1.Position := 0;
      StatusBar1.Panels[3].Text := '%0';
      StatusBar1.Panels[4].Text := '';
    end;
  end;
  // --End of codes that does the work

end;

procedure TForm1.BitBtn4Click(Sender: TObject); // --Open dest. folder
var
  folder: String;
begin
  if (open_folder.Text <> '') then
  begin
    folder := open_folder.Text;
    if (DirectoryExists(folder)) then
    begin
      ShellExecute(Handle, 'open', PChar(folder), nil, nil, SW_SHOWNORMAL);
    end;
  end;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
  stop := True;
end;

procedure TForm1.open_folderClick(Sender: TObject);
begin

  if (open_folder.Text = 'Select Output Folder') then
  begin
    open_folder.Text := '';
  end;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin

  Form2.ShowModal;

end;

end.
